#include <stdio.h>
#include "cv.h"
#include "cxcore.h"
#include "highgui.h"

#define PIXVAL(iplimagep, x, y)  (*(uchar *)((iplimagep)->imageData  + (y) * (iplimagep)->widthStep + (x)))


int
main()
{
	IplImage *img, *edge;

	img = cvLoadImage("lena_std.bmp", CV_LOAD_IMAGE_GRAYSCALE);
	if (!img) {
		fprintf(stderr, "file not found\n");
		return 1;
	}
	edge = cvCreateImage(cvGetSize(img), IPL_DEPTH_8U, 1);

	//cvSobel(img, edge, 1, 1, 3);
	cvCanny(img, edge, 100.0, 150.0, 3);

	cvNamedWindow("image", CV_WINDOW_AUTOSIZE);
	cvNamedWindow("edge", CV_WINDOW_AUTOSIZE);

	cvShowImage("image", img);
	cvShowImage("edge", edge);

	cvWaitKey(0); // always needed for showing images

	return 0;
}
